diff -urN nagios-plugins-1.3.0.orig/plugins/check_disk.c nagios-plugins-1.3.0/plugins/check_disk.c
--- nagios-plugins-1.3.0.orig/plugins/check_disk.c      2003-03-08 04:07:07.000000000 -0800
+++ nagios-plugins-1.3.0/plugins/check_disk.c   2003-03-08 04:08:06.000000000 -0800
@@ -56,4 +56,5 @@
 char *path = "";
 char *exclude_device = "";
 int verbose = 0;
+int erronly = FALSE;
 int display_mntp = FALSE;


@@ -118,2 +119,2 @@
                        if (strcmp (file_system, "none") == 0)
                                strncpy (file_system, mntp, MAX_INPUT_BUFFER-1);

+                       if (disk_result==STATE_OK && erronly && !verbose)
+                               continue;
+
                        if (disk_result!=STATE_OK || verbose>=0)
                                asprintf (&output, "%s [%d kB (%d%%) free on %s]", output,
                                          free_disk, 100 - usp, display_mntp ? mntp : file_system);
@@ -173,7 +177,8 @@
                {"partition", required_argument, 0, 'p'},
                {"verbose", no_argument, 0, 'v'},
                {"version", no_argument, 0, 'V'},
-               {"help", no_argument, 0, 'h'},
+                {"errors-only", no_argument, 0, 'e'},
+                {"help", no_argument, 0, 'h'},
                {"mountpoint", no_argument, 0, 'm'},
                {"exclude_device", required_argument, 0, 'x'},
                {"quiet", no_argument, 0, 'q'},
@@ -192,7 +197,7 @@
        while (1) {
 #ifdef HAVE_GETOPT_H
                c =
-                       getopt_long (argc, argv, "+?Vqhvt:c:w:p:x:m", long_options, &option_index);
+                       getopt_long (argc, argv, "+?Vqhvet:c:w:p:x:m", long_options, &option_index);
 #else
-               c = getopt (argc, argv, "+?Vqhvt:c:w:p:x:m");
+               c = getopt (argc, argv, "+?Vqhvet:c:w:p:x:m");
 #endif

                if (c == -1 || c == EOF)
@@ -250,6 +255,9 @@
                case 'q':                                                                       /* verbose */
                        verbose--;
                        break;
+               case 'e':
+                       erronly = TRUE;
+                       break;
                case 'm': /* display mountpoint */
                        display_mntp = TRUE;
                        break;
